"""globals.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This holds all of the important shit required more than once.
"""

import os, random

import cache

from messages import m

from pygame.locals import *

from user import home as HOME_PATH

HOME_PATH += os.path.sep
CONFIG_FILE = HOME_PATH+".tundra"

TUNDRA_VERSION = "0.7"

LEMMINGS_PATH = os.path.sep
ONML_PATH = os.path.sep

RESOURCES_PATH = os.getcwd()[:-3] # if you aren't keeping this file in the src/bin directory
                                  # you are deficient in basic intelligence

PLAYER_NAME = "Truffaut the Wonder Dog" 
START_COLLECTION = "Classic"

TITLE_FPS = 30
TITLE_SCROLL_SPEED = 200
TITLE_SCROLL_PAUSE = 4000
TITLE_SCROLL_YPOS = 402

MAX_LEVEL_WIDTH = 1584
MAX_LEVEL_HEIGHT = 160

LEVELDIALOG_WIDTH = 284
LEVELDIALOG_HEIGHT = 280

FINISHDIALOG_WIDTH = 284
FINISHDIALOG_HEIGHT = 280

QUICKLOADDIALOG_WIDTH = 480 
QUICKLOADDIALOG_HEIGHT = 200

LOADERDIALOG_WIDTH = 500
LOADERDIALOG_HEIGHT = 360

TOPBAR_HEIGHT = 40
PLAYAREA_HEIGHT = 320
NOTEBAR_HEIGHT = 40
SKILLBAR_HEIGHT = 80

SKILL_ORDER = ["s_climber", "s_floater", "s_bomber", "s_blocker", "s_builder", "s_basher", "s_miner", "s_digger"]

# when I made this a list and repeatedly called index(x) python made up things to complain about
NOTEBAR_ORDER = {"s_walker":0, "s_bounder":1, "s_faller":2, "s_shrugger":3, "s_burner":10, "s_drowner":11, "s_goner":12, "s_splatter":13, "s_bomber":14, "s_exploder":15, "s_blocker":20, "s_builder":21, "s_basher":22, "s_miner":23, "s_digger":24, "s_climber":30, "s_actclimber":31, "s_postclimber":32, "s_prefloater":40, "s_floater":41, "s_actfloater":42, "s_athlete":43, "s_leaver":50}

NOTEBAR_SKILL_ORDER = [] 

SCREEN_WIDTH = 640
SCREEN_WIDTH_DEFAULT = 640          # used for initially centering the playfield 
SCREEN_HEIGHT = TOPBAR_HEIGHT+PLAYAREA_HEIGHT+NOTEBAR_HEIGHT+SKILLBAR_HEIGHT

#SCREEN_RECT_PLAYAREA = Rect(0,TOPBAR_HEIGHT, SCREEN_WIDTH, PLAYAREA_HEIGHT)
#SCREEN_RECT_PANEL = Rect(0,TOPBAR_HEIGHT+PLAYAREA_HEIGHT, SCREEN_WIDTH, NOTEBAR_HEIGHT+SKILLBAR_HEIGHT)
#SCREEN_RECT = Rect(0,0,SCREEN_WIDTH, SCREEN_HEIGHT)

SCROLL_SPEED = 5

MINIMAP_WIDTH = int(0.375*SCREEN_WIDTH)
MINIMAP_HEIGHT = 56

MAP_KEY = {"ground":(0,128), "exit":(1,128), "trap":(1,64), "water":(1,32), "hazard":(1,16), 
           "leftArrows":(1,8), "rightArrows":(1,4), "steel":(1,2), "turnLeft":(2,128), "turnRight":(2,64) }

# by default this next colour is used to erase parts of images
# apologies to anyone planning a "hello kitty" themed level
DEFAULT_COLOURKEY = (255,40,255,255)
# TODO: find way of making blitting not alter exact RGB, remove yet another nasty hack
DEFAULT_COLOURKEY2 = (254,39,254,255)

# this is what bridges and uprooted dirt clods are painted by default
# it must be a string and not an actual tuple due to the way it's precached by style.py
FAVOURITE_COLOUR = "210,130,32"

# classic | random
PARTICLE_MODE = "classic"

ENABLE_MUSIC = True
RANDOM_MUSIC = False

# TODO: remove this and replace with configuration option
MUSIC_PLAYLIST = "random"

RELEASERATE_MIN = 1
RELEASERATE_MAX = 99
RELEASERATE_ADJUST = 6
FPS = 15
GAMESECOND = 8
FASTER_MULTIPLIER = 3

ENABLE_SMOOTHING = False
ENABLE_FULLSCREEN = False

# I'm going to be murdered if someone serious spots this
def refresh():
    globals()["MINIMAP_WIDTH"] = int(0.375*SCREEN_WIDTH)
    return

screen = None
clock = None
levelDB = {}

styleCache = cache.StyleCache()
skillCache = cache.SkillCache()
fontCache = cache.FontCache()
fontHighlightCache = cache.FontCache(name="font-highlight")
countdownCache = cache.CountdownCache()


def msg(name):
    x = m.get(name,"")
    if (x.__class__ == str):
        return x
    else:
        return x[random.randint(0,len(x)-1)]
