"""s_basher.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of punching through a wall.
"""

from excepts import *

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": True, "propertyChangeOnly": False }
# -1/1 are the l/r animation frames, -2/2 are the l/r subtraction masks
frames = {-1:[[],None] , 1:[[],None], -2:[[],None], 2:[[],None]}

def update(lemming):



    for i in range(0,4):
        if (lemming.currentFrame == 2+i) or (lemming.currentFrame == 18+i):
            lemming.game.subtract(frames[lemming.direction*2][0][i], (lemming.rect.left, lemming.rect.top))        
        elif (lemming.currentFrame == 11+i ) or (lemming.currentFrame == 27+i ):
            lemming.posX += lemming.direction

    try:
        if lemming.direction == -1:
            bound = lemming.rect.left
            block = "rightArrows"
        else:
            bound = lemming.rect.right
            block = "leftArrows"

        if (lemming.currentFrame == 6) or (lemming.currentFrame == 22):
            if not lemming.checkPos((bound, lemming.rect.centery), "ground"):
                lemming.setSkill("s_walker")
                return
               
        test = lemming.checkPos((bound, lemming.rect.centery), "steel")
        test |= lemming.checkPos((bound, lemming.rect.centery), block) 
        if test:
            lemming.setSkill("s_walker")
            return
    except OutOfThePlayfield:
        pass
#       
      
#           for i in range(1,9):
#                if not lemming.checkPos((lemming.rect.centerx + 8*lemming.direction, lemming.rect.bottom - i), "ground"): # check in front
#                    lemming.setSkill("s_walker")
#                    return

# more than a 1px drop will change to faller

    lemming._incAnimFrame()
    return

def set(lemming):
    lemming.currentSkill = "s_basher"
    lemming.currentFrame = 0
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
    
