"""s_bounder.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of a lemming bounding over a tall bit of terrain.
"""

from excepts import *

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

def update(lemming):
    try:
        if not (lemming.checkPos((lemming.posX, lemming.posY), "ground")):
            lemming.setSkill("s_walker")
        elif not (lemming.checkPos((lemming.posX, lemming.posY-1), "ground")):
            lemming.posY -= 1
            lemming._incAnimFrame()
        elif not (lemming.checkPos((lemming.posX, lemming.posY-2), "ground")):
            lemming.posY -= 2
            lemming._incAnimFrame()
        else: 
            lemming.posY -= 2
            lemming._incAnimFrame()

        if (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY-1), "exit" )):
            lemming.posX += lemming.direction
            lemming.setSkill("s_leaver") 
    except OutOfThePlayfield:
        lemming.kill()    
    return

def set(lemming):
    lemming.currentSkill = "s_bounder"
    lemming.currentFrame = 0
    lemming.rect.left = frames[lemming.direction][1].left
    lemming.rect.right = frames[lemming.direction][1].right
    lemming.rect.width = frames[lemming.direction][1].width
    lemming.rect.height = frames[lemming.direction][1].height
    lemming.frameCount = len(frames[lemming.direction][0])
    lemming._incAnimFrame()
    return 
