"""s_walker.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming walker action.
"""

from excepts import *

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

def update(lemming):
    try:
        if (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY), "ground" )):  
            if not (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY-1), "ground")):
                lemming.posX += lemming.direction
                lemming.posY -= 1
                lemming._incAnimFrame()
            elif not (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY-2), "ground")):
                lemming.posX += lemming.direction
                lemming.posY -= 2
                lemming._incAnimFrame()
            else:
                check = False
                for i in range(lemming.posY-3, lemming.posY-lemming.MAX_BOUND_HEIGHT-1, -1):
                    check = check or not (lemming.checkPos((lemming.posX+lemming.direction,i),"ground"))
                if check:
                    lemming.posY -= 2
                    lemming.posX += lemming.direction                    
                    lemming.setSkill("s_bounder")
                elif lemming.isClimber:
                    lemming.setSkill("s_actclimber")
                else: 
                    lemming.posX += lemming.direction # this line was put in to shut up any trainspotters that would
                                                      # complain about movement being put out by exactly one pixel
                    lemming.direction *= -1
                    lemming._incAnimFrame()
        elif (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY+1), "ground")):
            lemming.posX += lemming.direction
            lemming._incAnimFrame()
        elif (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY+2), "ground")):
            lemming.posX += lemming.direction
            lemming.posY += 1
            lemming._incAnimFrame()
        elif (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY+3), "ground")):
            lemming.posX += lemming.direction
            lemming.posY += 2
            lemming._incAnimFrame()
        else:
            lemming.posX += lemming.direction
            lemming.posY += 2
            lemming.setSkill("s_faller")

    except OutOfThePlayfield:
        lemming.kill()

    try:
        if (lemming.checkPos((lemming.posX+lemming.direction, lemming.posY+4), "exit" )):
            lemming.posX += lemming.direction
            lemming.setSkill("s_leaver") 
    except OutOfThePlayfield:
        pass

    return

def set(lemming):
    if lemming.altitude >= lemming.MAX_FALL:
        lemming.setSkill("s_splatter")
    else:
        lemming.currentSkill = "s_walker"
        lemming.currentFrame = 0
        lemming.rect.left = frames[lemming.direction][1].left
        lemming.rect.right = frames[lemming.direction][1].right
        lemming.rect.width = frames[lemming.direction][1].width
        lemming.rect.height = frames[lemming.direction][1].height
        lemming.frameCount = len(frames[lemming.direction][0])
        lemming._incAnimFrame()
    return

